; 
 
.486                             ; set processor model
.model flat, stdcall         ; default STDCALL calling convention
option casemap :none    ; always use the case sensitive option 
 

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\ole32.inc
include  \masm32\owm\include\CObject.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\ole32.lib

.data

COINIT  IUnknown
COINIT  IClassFactory

TBLINIT CObject
TBLINIT CUnknown

.code

; 
CoCreate  proc    uses esi edi vmtObject:DWORD, CLSII:DWORD, Contx:DWORD
LOCAL pv: DWORD

    invoke CoCreateInstance, CLSII,NULL,Contx,GetGUID(IUnknown),ADDR pv

    .if eax==S_OK
                
        mov eax, pv
        mov edi,vmtObject
        mov edx, [edi]
        test edx, edx
        jnz @@Exit

        mov esi, [eax]
        mov ecx, [edi + vmtOffsetVMTSize]
        shr ecx, 2
        cld
        rep movsd
                
    .else
        xor eax, eax    
    .endif
    
@@Exit:
    ret
    
CoCreate  endp

; Methods CObject
; 
ptrCreateObject    proc C uses ebx esi edi  vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov ebx, vmtObject
    invoke LocalAlloc,GMEM_FIXED or GMEM_ZEROINIT,[ebx + vmtOffsetInstanceSize]
    or eax, eax
    jz  @@Exit

    mov edi, eax   
    mov esi, [ebx + vmtOffsetDateTable]
    mov edx, [ebx + vmtOffsetInstanceSize]
    mov ecx, edx
    shr ecx, 2
    cld
    rep movsd
    mov ecx, edx 
    and ecx, 03h
    rep movsb
           
    mov ecx, Count
    or ecx, ecx
    jz @@Init

@@Loop:
    push [ebp + ecx*4 + 12]      
    dec ecx
    jnz @@Loop
@@Init:
    mov [eax], ebx                                                      ; Set CObject.vmtable     
    xchg eax, ebx            
    push ebx

    call (VMT_CObject PTR [eax]).InitInstance

    mov eax, ebx
@@Exit:        
    ret
    
ptrCreateObject    endp

; 
ptrGetInstanceSize  proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
    mov eax, [eax + vmtOffsetInstanceSize]
    
    ret
    
ptrGetInstanceSize  endp

; 
ptrGetInitInstanceTable     proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
    mov eax, [eax + vmtOffsetDateTable]
    
    ret
    
ptrGetInitInstanceTable     endp

; 
ptrGetVirtualTable     proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
        
    ret
    
ptrGetVirtualTable     endp

; 
ptrGetVirtualTableSize     proc C vmtObject:DWORD, Count:DWORD, Data:VARARG

    mov eax, vmtObject
    mov eax, [eax + vmtOffsetVMTSize]
    
    ret
    
ptrGetVirtualTableSize     endp

; 
ptrInitInstance     proc lpThis:DWORD

    ret
    
ptrInitInstance     endp       

; 
ptrDestroyObject     proc lpThis:DWORD

    mov eax, lpThis
    or eax, eax
    je @@Exit
    invoke LocalFree, eax
    
@@Exit:        
    ret
    
ptrDestroyObject     endp

; 
ptrFreeObject   proc lpThis:DWORD

    invokemtd [lpThis].CObject.Destroy
   
    ret
    
ptrFreeObject   endp

; Methods CUnknown
; 
ptrInitInstance_CUnknown        proc  uses ebx  lpThis: DWORD    
        mov     eax, lpThis
        add     DWORD PTR [eax], vmtOffsetQueryInterface                                  ; Set vmtable for COM
        ret
ptrInitInstance_CUnknown        endp

; 
ptrQueryInterface       proc    lpThis: DWORD, pCLSID: DWORD,  ppv: DWORD

        invoke  IsEqualGUID, pCLSID, GetGUID(IUnknown)
        mov   edx, ppv
        .if eax
              mov eax, lpThis
              mov [edx], eax          
              invokemtd lpThis.CUnknown.AddRef       
              mov eax, S_OK
        .else
              mov DWORD PTR [edx], NULL
              mov eax, E_NOINTERFACE 
        .endif

       ret                 
ptrQueryInterface       endp

; 
ptrAddRef                   proc   lpThis: DWORD    
       mov    eax, lpThis
       inc     [eax].CUnknown.FRefCount
       mov    eax, [eax].CUnknown.FRefCount
       ret         
ptrAddRef                   endp

; 
ptrRelease                  proc   lpThis: DWORD    

       mov eax,  lpThis
       dec [eax].CUnknown.FRefCount
       mov eax, [eax].CUnknown.FRefCount
       
       .if eax == NULL
              invokemtd lpThis.CUnknown.Free         
              xor eax, eax
       .endif       

       ret 
ptrRelease                  endp

end