; 
.486                             ; set processor model
.model flat, stdcall         ; default STDCALL calling convention
option casemap :none    ; always use the case sensitive option 
 
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc
include \masm32\owm\include\cobject.inc

include \masm32\macros\macros.asm
       
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\owm\lib\cobject.lib


;macro

ADDRP   MACRO  addres:REQ
    lea eax, addres
    EXITM <eax>
ENDM  

ldeax	MACRO	Mem1,Mem2
	mov eax, Mem2
	mov Mem1, eax
ENDM


MAX_STRING_BUFFER       EQU     260
IDM_OPENFILE                  EQU     1
IDM_EXIT                         EQU     2

; // This structure not Window's.inc
CDN_FIRST                       EQU    -601;
CDN_LAST                        EQU    -699;

; Notifications when Open or Save dialog status changes 
CDN_INITDONE                 EQU     CDN_FIRST - 0;
CDN_SELCHANGE              EQU     CDN_FIRST - 1;
CDN_FOLDERCHANGE        EQU     CDN_FIRST - 2;
CDN_SHAREVIOLATION     EQU     CDN_FIRST - 3;
CDN_HELP                        EQU     CDN_FIRST - 4;
CDN_FILEOK                     EQU     CDN_FIRST - 5;
CDN_TYPECHANGE            EQU     CDN_FIRST - 6;
CDN_INCLUDEITEM            EQU     CDN_FIRST - 7;

OFNOTIFY        STRUCT
    hdr         NMHDR             <?>
    lpOFN     OPENFILENAME  <?>  
    pszFile    LPTSTR               ?
OFNOTIFY        ENDS
        
; ----------------------------------------------
; prototypes for local procedures go here
; ----------------------------------------------
 WinMain proto  hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 

;Demo Class
; 
CLASS COpenFileDialog, CObject
OVERRID   InitInstance               :PTRPROTO@16=ptrInitInstance_COpenFileDialog         ;; VIRTUAL procedure
CMETHOD  WndProc                   :PTRPROTO@16=ptrWndProc_COpenFileDialog             ;; VIRTUAL Function
CMETHOD  DefWndProc              :PTRPROTO@20=ptrDefWndProc_COpenFileDialog         ;; Static procedure    Not DefaultWndProc , CATSTR translit defaultWndProc - Error Compile
;;CMETHOD  CenterWindow           :PTRPROTO@4=ptrCenterWindow_COpenFileDialog       ;; Static procedure
FIELD         hWnd                        :HWND           =   NULL 
FIELD         FileName                   :BYTE             =   MAX_STRING_BUFFER dup(NULL) 
FIELD         FlagOption                 :DWORD         =    OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_LONGNAMES or OFN_HIDEREADONLY  or  OFN_CREATEPROMPT  or OFN_ENABLEHOOK 
FIELD         DefWndProc               :DWORD         =    NULL    
ENDCLASS

.data
  TBLINIT COpenFileDialog                              ;; Init VMT Table and DATA table
  ClassName   db "WinMasm32App",0
  AppName     db "OpenFile",0
  MenuName   db "FirstMenu",0
  TitleBox       db  "Get FileName",0
  szFilter        db  "All files (*.*)",0,"*.*",0,"Text files (*.txt)",0,"*.txt",0,0
     
.data?
  hInstance           HINSTANCE   ?
  CommandLine     LPSTR          ?
        
.code

start: 

     invoke GetModuleHandle, NULL
     mov    hInstance,eax
     invoke GetCommandLine

     mov CommandLine,eax
     invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWNORMAL
     invoke ExitProcess,eax
 
; 
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
LOCAL wc:WNDCLASSEX 
LOCAL msg:MSG 
LOCAL hwnd:HWND 

     mov   wc.cbSize,SIZEOF WNDCLASSEX
     mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
     mov   wc.lpfnWndProc, OFFSET WndProc
     mov   wc.cbClsExtra,NULL
     mov   wc.cbWndExtra,NULL
     ldeax  wc.hInstance, hInst
     mov   wc.hbrBackground,COLOR_WINDOW+1
     mov   wc.lpszMenuName,OFFSET MenuName         
     mov   wc.lpszClassName,OFFSET ClassName
     invoke LoadIcon,NULL,IDI_APPLICATION
     mov   wc.hIcon,eax
     mov   wc.hIconSm,eax
     invoke LoadCursor,NULL,IDC_ARROW
     mov   wc.hCursor,eax

     invoke RegisterClassEx, addr wc
     invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
                                 WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
                                 CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
                                 hInst,NULL
     mov   hwnd,eax
     invoke ShowWindow, hwnd,CmdShow
     invoke UpdateWindow, hwnd

     .while TRUE

         invoke GetMessage, ADDR msg,NULL,0,0
         .break .if (!eax)
         ;invoke TranslateMessage, ADDR msg        ; no comment Virtual key
         invoke DispatchMessage, ADDR msg

     .endw

     mov     eax,msg.wParam
     ret

WinMain endp

; 
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 
LOCAL ptrOpenFile:DWORD

     .if uMsg==WM_DESTROY
         invoke PostQuitMessage,NULL
     .elseif uMsg==WM_COMMAND
        mov eax,wParam
        .if ax == IDM_OPENFILE
            invokemtd COpenFileDialog.Create, hWnd, hInstance, OFFSET szFilter             ;Create Object and Init and Explorer Run 
            mov ptrOpenFile, eax
            invoke MessageBox,hWnd,ADDRP ([eax].COpenFileDialog.FileName),OFFSET TitleBox,MB_OK or MB_ICONINFORMATION
            invokemtd [ptrOpenFile].COpenFileDialog.Free                                               ; Destroy object 
        .else
            invoke DestroyWindow,hWnd
        .endif       
     .else
         invoke DefWindowProc,hWnd,uMsg,wParam,lParam
         ret
     .endif

     xor    eax,eax
     ret

WndProc endp

; 
ptrDefWndProc_COpenFileDialog   proc lpThis:DWORD,Wnd:HWND,Msg:UINT,wParam:WPARAM,lParam:LPARAM

    mov eax, lpThis
     
    invoke CallWindowProc,[eax].COpenFileDialog.DefWndProc,Wnd,Msg,wParam,lParam

     
    ret
    
ptrDefWndProc_COpenFileDialog   endp

; 
FillChar        proc uses edi Buffer:DWORD, Count:DWORD, Char: BYTE

    mov edi, Buffer
    mov cl, Char
    mov ch,cl
    mov eax, ecx
    shl eax, 16
    mov ax, cx

    mov edx, Count
    mov ecx, edx
    sar  ecx, 2
    js @@Exit
    rep stosd
    mov ecx, edx
    and ecx, 03h
    rep stosb

@@Exit:
    ret
FillChar        endp

; 
ptrWndProc_COpenFileDialog      proc Wnd:HWND,Msg:UINT,wParam:WPARAM, lParam:LPARAM
LOCAL lpThis:DWORD

    invoke GetWindowLong,Wnd,GWL_USERDATA
    mov lpThis, eax
    
    .if Msg ==  WM_INITDIALOG
        ret
    .elseif Msg == WM_NOTIFY
        mov edx, lParam
        assume edx: PTR OFNOTIFY
        .if [edx].hdr.NMHDR.code == CDN_FILEOK
           ;;invoke SetWindowLong, Wnd,DWL_MSGRESULT, 1
            xor eax,eax
            ret
        .endif
        assume edx: PTR nothing
    .endif

    invokemtd [lpThis].COpenFileDialog.DefWndProc,Wnd,Msg,wParam,lParam        
   
    ret
    
ptrWndProc_COpenFileDialog      endp

; 
ExplorerHook        proc uses ebx Wnd:HWND,Msg:UINT,wParam:WPARAM, lParam:LPARAM

    .if Msg ==  WM_INITDIALOG
        mov ebx, lParam
        mov ebx, [ebx].OPENFILENAME.lCustData
        ldeax [ebx].COpenFileDialog.hWnd, Wnd
        invoke SetWindowLong,Wnd,GWL_WNDPROC, OFFSET ptrWndProc_COpenFileDialog
        mov [ebx].COpenFileDialog.DefWndProc, eax
        invoke SetWindowLong,Wnd,GWL_USERDATA, ebx
        invoke CallWindowProc,OFFSET ptrWndProc_COpenFileDialog,Wnd,Msg,wParam,lParam
    .endif
    
    ret
    
ExplorerHook        endp

; 
ptrInitInstance_COpenFileDialog     proc uses ebx lpThis:DWORD, hParent:HWND, Instance:HINSTANCE, lpFilter:DWORD
LOCAL   ofn: OPENFILENAME

    mov ebx, lpThis
    assigned  ebx: COpenFileDialog     ;; assume edx: PTR COpenFileDialog and Stack vmtassigned_edx =COpenFileDialog, warning not memory assume and Stack!
            
    inherited [ebx].InitInstance          ; Inherited CObject.InitInstance. Not forma "inherited [lpThis].InitInstance" = Error!, inherited [lpThis].COpenFileDialog.InitInstance
                                                    ; invokemtd [ebx].InitInstance not Inherited!!! --  [ebx].COpenFileDialog.InitInstance   
                                                    ; invokemtd [ebx].CObject.InitInstance, Yes Inherited!                                                          
    invoke FillChar, ADDR ofn, sizeof OPENFILENAME,NULL
                
    mov ofn.lCustData, ebx
    mov ofn.lStructSize, sizeof OPENFILENAME
    ldeax ofn.hWndOwner, hParent
    ldeax ofn.hInstance, Instance
    ldeax ofn.lpstrFilter, lpFilter
    mov ofn.nFilterIndex,1
    mov ofn.lpstrFile, ADDRP([ebx].FileName)
    mov ofn.nMaxFile, MAX_STRING_BUFFER
    ldeax ofn.Flags, [ebx].FlagOption
    mov ofn.lpfnHook, OFFSET ExplorerHook
    
    invoke GetOpenFileName,ADDR ofn

    assigned  ebx: nothing
    ret
    
ptrInitInstance_COpenFileDialog     endp

;  
end start
