; 

      .486                               ; create 32 bit code
      .model flat, stdcall           ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\ole32.inc
      include \masm32\include\user32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\advapi32.inc
      include \masm32\include\masm32.inc
      include \masm32\owm\include\cobject.inc
      
      include \masm32\macros\macros.asm     ; the macro file
      include \masm32\owm\macros\system.mac

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\user32.lib  
      includelib \masm32\lib\ole32.lib
      includelib  \masm32\lib\oleaut32.lib
      includelib  \masm32\lib\advapi32.lib
      includelib \masm32\lib\masm32.lib
      includelib \masm32\owm\lib\cobject.lib

    ; ----------------------------------------
    ; prototypes for local procedures go here
    ; ----------------------------------------

      GuardedDeleteKey        PROTO :DWORD, :DWORD

       CLSIID   CLSID_MyCom,	{A21A8C42-1266-11D4-A3240040F6D487D9}
       CLSIID   IMyCom,		{A21A8C41-1266-11D4-A3240040F6D487D9}
  
       CLASS  CMyCom, CUnknown
              OVERRID	QueryInterface	:PTRPROTO@12	=ptrQueryInterface_CMyCom
              CMETHOD	GetValue	:PTRPROTO@8	=ptrGetValue 
              CMETHOD	SetValue	:PTRPROTO@8	=ptrSetValue
              FIELD  	FValue		:DWORD	=  0
       ENDCLASS
  
       CLASS  CClassFactory, CUnknown
              OVERRID	QueryInterface	:PTRPROTO@12	=ptrQueryInterface_CClassFactory
              CMETHOD	CreateInstance	:PTRPROTO@16	=ptrCreateInstance
              CMETHOD	ptrLockServer	:PTRPROTO@8	=ptrLockServer
       ENDCLASS	
       
      .data
            TBLINIT CMyCom
            TBLINIT CClassFactory
                       
            ; strings needed to register the component
            szSampleDesc        BYTE    "CMyCom simple client thing", 0
            szInprocServer32    BYTE    "InprocServer32", 0
            szSampleProgID      BYTE    "CMyCom", 0
            szProgID                BYTE    "CMyCom", 0
            szThreadModel       BYTE    "ThreadingModel", 0
            szThreadType        BYTE    "Both",0
            szCLSID                 BYTE    "CLSID"              ,0
      
            
      .data?
        hInstance        dd      ?
        ObjCF             dd      ?

      .code

; 
LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    .if reason == DLL_PROCESS_ATTACH
        mem hInstance, instance
        invokemtd CClassFactory.Create
        mov ObjCF, eax
        mov eax, TRUE
    .else
        mov eax, FALSE
    .endif

    ret

LibMain endp

; 
DllCanUnloadNow proc
    .if (ObjCF.CClassFactory.FRefCount == NULL)
        mov eax, TRUE
    .ELSEIF
        mov eax, FALSE
    .ENDIF
    ret
DllCanUnloadNow Endp

; 
DllGetClassObject proc pCLSID:DWORD, pIID:DWORD, ppv:DWORD
LOCAL   hr        :DWORD

    invoke  IsEqualGUID, pCLSID, GetGUID(CLSID_MyCom)
    .if (eax == TRUE)
        invokemtd ObjCF.CClassFactory.QueryInterface, pIID, ppv
        mov hr, eax
        ;invokemtd ObjCF.CClassFactory.Release
    .else
        mov hr, CLASS_E_CLASSNOTAVAILABLE
    .endif  
    mov eax, hr         ; pass back the hresult
    ret
    
DllGetClassObject Endp

; 
DllRegisterServer proc
    LOCAL   hKey    :DWORD
    LOCAL   hKey2   :DWORD
    LOCAL   hKey3   :DWORD
    LOCAL   sBuf    [MAX_PATH]:BYTE
    LOCAL   wsBuf   [MAX_PATH]:WORD
    LOCAL   psBuf   :DWORD
    LOCAL   pwsBuf  :DWORD
    LOCAL   pti     :DWORD
    
    ; assign the pointers to the local text buffers
    lea eax, sBuf
    mov psBuf, eax
    lea eax, wsBuf
    mov pwsBuf, eax
    ; Create HKEY_CLASSES_ROOT\progid\CLSID
    invoke RegCreateKey, HKEY_CLASSES_ROOT, ADDR szSampleProgID, ADDR hKey
    .IF (eax != ERROR_SUCCESS)
        jmp @@Exit
    .ENDIF
    invoke lstrlen, ADDR szSampleDesc    
    invoke RegSetValue,hKey, NULL, REG_SZ, ADDR szSampleDesc, eax
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    ; Create HKEY_CLASSES_ROOT\%szProgID%\CLSID 
    invoke RegCreateKey, hKey, ADDR szCLSID, ADDR hKey2
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    ; convert the CLSID_MyCom number to a string    
    invoke StringFromGUID2, GetGUID(CLSID_MyCom), pwsBuf, MAX_PATH
    invoke WideCharToMultiByte, CP_ACP, 0, pwsBuf, -1, 
                                psBuf, MAX_PATH, NULL, NULL
    invoke lstrlen, psBuf
    invoke RegSetValue, hKey2, NULL, REG_SZ, psBuf, eax
    .IF (eax != ERROR_SUCCESS)
        jmp @@Exit
    .ENDIF

    invoke RegCloseKey, hKey
    invoke RegCloseKey, hKey2
    ; Create HKEY_CLASSES_ROOT\CLSID
    invoke RegCreateKey, HKEY_CLASSES_ROOT, ADDR szCLSID, ADDR hKey
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    ; Create HKEY_CLASSES_ROOT\CLSID\%GUID%
    invoke RegCreateKey, hKey, psBuf, ADDR hKey2
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    ; put in sample description value into CLSID\GUID key
    invoke lstrlen, ADDR szSampleDesc    
    invoke RegSetValue, hKey2, NULL, REG_SZ, ADDR szSampleDesc, eax
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    ; get our path ..
    invoke GetModuleFileName,hInstance, psBuf, MAX_PATH
    .IF (eax == 0) 
        mov eax, 1
        jmp @@Exit
    .ENDIF
    ; Create HKEY_CLASSES_ROOT\CLSID\%GUID%\InprocServer32
    invoke RegCreateKey, hKey2, ADDR szInprocServer32, ADDR hKey3
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    ; set key value to the path obtained above
    invoke RegSetValue, hKey3, NULL, REG_SZ, psBuf, MAX_PATH
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    ; set the threading type value
    invoke lstrlen, ADDR szThreadType
    invoke RegSetValueEx, hKey3, ADDR szThreadModel, 0, REG_SZ, ADDR szThreadType, eax
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    invoke RegCloseKey, hKey3
    ; Create HKEY_CLASSES_ROOT\CLSID\%GUID%\%szProgID% 
    invoke RegCreateKey, hKey2, ADDR szProgID, ADDR hKey3
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    invoke lstrlen, ADDR szSampleProgID
    invoke RegSetValue, hKey3, NULL, REG_SZ, ADDR szSampleProgID, eax
    .IF (eax != ERROR_SUCCESS) 
        jmp @@Exit
    .ENDIF
    invoke RegCloseKey, hKey3
    .IF (hKey != 0)
        invoke RegCloseKey, hKey
    .ENDIF    
    .IF (hKey2 != 0)
        invoke RegCloseKey, hKey2
    .ENDIF    
    .IF (hKey3 != 0)
        invoke RegCloseKey, hKey3
    .ENDIF    
    ; sBuf still has our dll pathname, lets use it to
    ; get the class type library
    Invoke MultiByteToWideChar, CP_ACP, 0, psBuf, -1, pwsBuf, MAX_PATH
    .IF !eax
        mov eax, S_FALSE
        jmp @@Exit
    .ENDIF
    lea eax, pti
    Invoke LoadTypeLib, pwsBuf, eax
    .IF (eax != ERROR_SUCCESS)
        mov eax, S_FALSE
        jmp @@Exit
    .ENDIF
    ; and register the type lib
    Invoke RegisterTypeLib, pti, pwsBuf, NULL
    .IF (eax != ERROR_SUCCESS)
        mov eax, S_FALSE
        jmp @@Exit
    .ELSE
        ; release the type info pointer we got
        ; NOTE: the 3 following lines could be substuited with
        ;       the coinvoke macro like so:
        ;  coinvoke pti, IUnknown, Release
        mov eax, pti
        mov eax, [eax]
        invoke (IUnknown PTR [eax]).Release, pti
    .ENDIF
    xor eax, eax    ;    mov eax, S_OK
@@Exit:
    ret
DllRegisterServer endp

; 
DllUnregisterServer proc
    LOCAL   hSubkey:DWORD
    LOCAL   hSubkey2:DWORD
    LOCAL   sBuf    [MAX_PATH]:BYTE
    LOCAL   psBuf   :DWORD
    LOCAL   wsBuf   [MAX_PATH]:WORD
    LOCAL   pwsBuf  :DWORD

    lea eax, sBuf
    mov psBuf, eax
    lea eax, wsBuf
    mov pwsBuf, eax
    invoke StringFromGUID2, GetGUID(CLSID_MyCom), pwsBuf, MAX_PATH
    invoke WideCharToMultiByte, CP_ACP, 0, pwsBuf, -1, 
                                psBuf, MAX_PATH, NULL, NULL
    invoke GuardedDeleteKey, HKEY_CLASSES_ROOT, ADDR szSampleProgID
    .IF (eax != ERROR_SUCCESS)        
        jmp @@Exit
    .ENDIF
    invoke RegOpenKey, HKEY_CLASSES_ROOT, ADDR szCLSID, ADDR hSubkey
    invoke GuardedDeleteKey, hSubkey, psBuf
    .IF (eax != ERROR_SUCCESS)        
        jmp @@Exit
    .ENDIF
    invoke RegCloseKey, hSubkey
    xor eax, eax    ; mov eax, S_OK
@@Exit:    
    ret
DllUnregisterServer endp

; 
GuardedDeleteKey proc hKey:DWORD, lpszSubKey:DWORD
    LOCAL   szSubKeyName    [MAX_PATH+1]:TCHAR
    LOCAL   hSubkey         :DWORD  

    ; check to see if the key to be deleted still has subkey, 
    ; if not delete it, otherwise delete the subkey
    invoke RegOpenKey, hKey, lpszSubKey, ADDR hSubkey
    .IF (eax != ERROR_SUCCESS) 
        mov eax, REGDB_E_INVALIDVALUE
        jmp @@Exit
    .ENDIF
KillNextSubkey:    
    ; check for a subkey
    invoke RegEnumKey, hSubkey, 0, ADDR szSubKeyName, MAX_PATH+1
    .IF (eax != ERROR_NO_MORE_ITEMS) ; IF SubKeys exist...
        ; delete the subkey thru recusion
        invoke GuardedDeleteKey, hSubkey, ADDR szSubKeyName
        jmp KillNextSubkey
    .ELSE
    .ENDIF
    ; no more Subkeys, delete the specfied hey.
    invoke RegCloseKey, hSubkey
    invoke RegDeleteKey, hKey,  lpszSubKey
    .IF (eax == ERROR_SUCCESS) 
        xor eax, eax  ; mov eax, S_OK
    .ENDIF
@@Exit:
    ret
GuardedDeleteKey endp

; Methods CClassFactory
; 
ptrQueryInterface_CClassFactory       proc    lpThis: DWORD, pCLSID: DWORD,  ppv: DWORD
LOCAL Flag: DWORD

        invoke  IsEqualGUID, pCLSID, GetGUID(IUnknown)
        mov   Flag, eax
        invoke  IsEqualGUID, pCLSID, GetGUID(IClassFactory)
        or    eax, Flag
        mov   edx, ppv
        .if eax
              mov eax, lpThis
              mov [edx], eax          
              invokemtd lpThis.CClassFactory.AddRef       
              mov eax, S_OK
        .else
              mov DWORD PTR [edx], NULL
              mov eax, E_NOINTERFACE 
        .endif

       ret                 
ptrQueryInterface_CClassFactory       endp

; 
ptrCreateInstance           proc   uses ebx lpThis: DWORD, pUnknownOuter: DWORD, pIID: DWORD, ppv: DWORD
LOCAL hr: DWORD

       .if pUnknownOuter != NULL
              mov hr, CLASS_E_NOAGGREGATION
       .else
              invokemtd CMyCom.Create
              .if eax == NULL                
                     mov hr, E_OUTOFMEMORY
              .else
                     mov ebx, eax
                     mov eax, lpThis
                     inc [eax].CClassFactory.FRefCount 
                     invokemtd ebx.CMyCom.QueryInterface , pIID, ppv
                     mov hr, eax
                     invokemtd ebx.CMyCom.Release
              .endif
       .endif
       mov eax, hr
       
    ret
ptrCreateInstance           endp

; 
ptrLockServer               proc   lpThis: DWORD, bLockServer: DWORD

       mov eax, lpThis
       .if    bLockServer
              inc [eax].CClassFactory.FRefCount                     
       .else
               dec [eax].CClassFactory.FRefCount
       .endif
       mov eax, S_OK
       ret    

ptrLockServer               endp

; Methods CMyCom
; 
ptrQueryInterface_CMyCom       proc    lpThis: DWORD, pCLSID: DWORD,  ppv: DWORD
LOCAL Flag: DWORD

        invoke  IsEqualGUID, pCLSID, GetGUID(IUnknown)
        mov   Flag, eax
        invoke  IsEqualGUID, pCLSID, GetGUID(IMyCom)
        or    eax, Flag
        mov   edx, ppv
        .if eax
              mov eax, lpThis
              mov [edx], eax          
              invokemtd lpThis.CMyCom.AddRef       
              mov eax, S_OK
        .else
              mov DWORD PTR [edx], NULL
              mov eax, E_NOINTERFACE 
        .endif

       ret                 
ptrQueryInterface_CMyCom       endp

; 
ptrGetValue proc this_:DWORD, pval:DWORD
    mov eax, this_
    mov eax, [eax].CMyCom.FValue
    mov edx, pval
    mov [edx], eax
    xor eax, eax        ; return S_OK
    ret
ptrGetValue endp

; 
ptrSetValue proc this_:DWORD, pval:DWORD
    mov eax, this_
    mov edx, pval
    mov [eax].CMyCom.FValue, edx
    xor eax, eax        ; return S_OK
    ret
ptrSetValue endp

end LibMain
